package java.io;

public class FileInputStream extends InputStream {
   // $FF: renamed from: fd java.io.FileDescriptor
   private FileDescriptor field_0;

   public FileInputStream(String name) throws FileNotFoundException {
      SecurityManager security = System.getSecurityManager();
      if (security != null) {
         security.checkRead(name);
      }

      try {
         this.field_0 = new FileDescriptor();
         this.open(name);
      } catch (IOException var3) {
         throw new FileNotFoundException(name);
      }
   }

   public FileInputStream(File file) throws FileNotFoundException {
      this(file.getPath());
   }

   public FileInputStream(FileDescriptor fdObj) {
      SecurityManager security = System.getSecurityManager();
      if (security != null) {
         security.checkRead(fdObj);
      }

      this.field_0 = fdObj;
   }

   private native void open(String var1) throws IOException;

   public native int read() throws IOException;

   private native int readBytes(byte[] var1, int var2, int var3) throws IOException;

   public int read(byte[] b) throws IOException {
      return this.readBytes(b, 0, b.length);
   }

   public int read(byte[] b, int off, int len) throws IOException {
      return this.readBytes(b, off, len);
   }

   public native long skip(long var1) throws IOException;

   public native int available() throws IOException;

   public native void close() throws IOException;

   public final FileDescriptor getFD() throws IOException {
      if (this.field_0 != null) {
         return this.field_0;
      } else {
         throw new IOException();
      }
   }

   protected void finalize() throws IOException {
      if (this.field_0 != null) {
         this.close();
      }

   }
}
