package java.io;

public class FilterOutputStream extends OutputStream {
   protected OutputStream out;

   public FilterOutputStream(OutputStream out) {
      this.out = out;
   }

   public void write(int b) throws IOException {
      this.out.write(b);
   }

   public void write(byte[] b) throws IOException {
      this.write(b, 0, b.length);
   }

   public void write(byte[] b, int off, int len) throws IOException {
      for(int i = 0; i < len; ++i) {
         this.out.write(b[off + i]);
      }

   }

   public void flush() throws IOException {
      this.out.flush();
   }

   public void close() throws IOException {
      this.flush();
      this.out.close();
   }
}
